<?
  error_reporting(E_ALL);

  // [text]
  function tmpl_text_replacer($tmpl, $text_arr, $text_block)
  {
/*
[text] [text]
(tmpl) (conf)
 
   0     0 -   
   0     1 -   
   1     0 -    
   1     1 -        
*/
    $text_block_preg = preg_quote($text_block);
    $tmpl_out = $tmpl;

    if(strpos($tmpl, $text_block) === false)
      $text_tmpl = 0; else
      $text_tmpl = 1;

    $count_text_arr = count($text_arr);

    if($count_text_arr)
      $text_conf = 1; else
      $text_conf = 0;

    if( ($text_tmpl === 1) && ($text_conf === 0) )
    {
      $tmpl_out = preg_replace('/(.+)[\r].*[\n].*' . $text_block_preg . '(.*)/s', '$1$2', $tmpl_out);
    }

    if( ($text_tmpl === 1) && ($text_conf === 1) )
    {
      preg_match('/(.+)\n(.+)' . $text_block_preg . '(.*)/s', $tmpl_out, $m);
      $spaces = $m[2];

      $text = '';

      for($i = 0; $i < $count_text_arr; $i++)
        $text .= $spaces . $text_arr[$i] . "\n";

      $tmpl_out = $m[1] . "\n" . $text . ltrim($m[3], "\r\n");
    }

    return $tmpl_out;
  }

  function tmpl_replacer($tmpl, $vhost_arr, $not_found_block)
  {
    //   [block_name]
    $block_count = preg_match_all('/\[([A-Za-z0-9_]+)\]/s', $tmpl, $m1);

    if($block_count)
    {
      $found_block = array_unique($m1[1]);
      $found_block = array_values($found_block);
      $count_found_block = count($found_block);
  
      for($i = 0; $i < $count_found_block; $i++)
      {
        if(isset($vhost_arr[$found_block[$i]]))
          $tmpl = str_replace('[' . $found_block[$i] . ']', $vhost_arr[$found_block[$i]], $tmpl); else
          $tmpl = str_replace('[' . $found_block[$i] . ']', $not_found_block, $tmpl); 
      }
    }
    //end

    // [block_name ? ...]
    $block_count = preg_match_all('/\[(.*?)\s+\?\s+(.*?)\]/s', $tmpl, $m2);

    if($block_count)
    {
      for($i = 0; $i < $block_count; $i++)
      {
        if(isset($vhost_arr[$m2[1][$i]]))
          $tmpl = str_replace($m2[0][$i], $vhost_arr[$m2[1][$i]], $tmpl); else
          $tmpl = str_replace($m2[0][$i], $m2[2][$i], $tmpl);
      
      }
    }
    //end

    return $tmpl;
  }
  
//////////////////////////

  $dnf  = dirname(__FILE__);
  $dnfs = $dnf . '/';

  $tmpl_dir   = $dnfs . 'template';
  $vhost_dir  = $dnfs . 'vhost';
  $text_block      = '[text]';
  $not_found_block = 'NOT_FOUND';

  if(isset($_SERVER['argv'][1]))
  {
    $tmpl_fname = $_SERVER['argv'][1];
    $tmpl = $tmpl_dir . '/' . $tmpl_fname;

    if(file_exists($tmpl))
    {
      $tmpl_src = file_get_contents($tmpl);

      $vhost = glob($vhost_dir . '/*');
      sort($vhost);

      $out = '';

      $count_vhost = count($vhost);

      //  vhost
      for($i = 0; $i < $count_vhost; $i++)
      {
        // 
        if(isset($vhost_arr))
          unset($vhost_arr);

        $vhost_arr = array();
        $vhost_arr['text'] = array();

        $vhost_arr_text_str_count = 0;
        //end

        if(is_file($vhost[$i]))
        {
          $cur_vhost = file_get_contents($vhost[$i]);
          $cur_vhost = explode("\n", $cur_vhost);
          $count_cur_vhost = count($cur_vhost);
  
          for($j = 0; $j < $count_cur_vhost; $j++)
          {
            $cur_vhost_src[$j] = $cur_vhost[$j];
            $cur_vhost[$j] = trim($cur_vhost[$j]);
  
            //  
            if(strlen($cur_vhost[$j]))
            {
              if($cur_vhost[$j][0] == '[')
              {
                //
                preg_match('/\[(.+)\][ \t]+(.+)/s', $cur_vhost[$j], $m);
  
                if(isset($m[2]))
                {
                  $vhost_arr[$m[1]] = $m[2];
                } else
                {
                  echo '   ' . $cur_vhost[$j];
                  die;
                }
                //end
              } else
              {
                //text
                $vhost_arr['text'][$vhost_arr_text_str_count] = $cur_vhost_src[$j];
                $vhost_arr_text_str_count++;
                //end
              }
            }
            //end
          }

          $tmpl_no_text_block = tmpl_text_replacer($tmpl_src, $vhost_arr['text'], $text_block);
          $out .= tmpl_replacer($tmpl_no_text_block, $vhost_arr, $not_found_block);
        }
//die;
      }
      //end

      //
      $tmpl_pre = $tmpl . '_pre';
      if(file_exists($tmpl_pre))
        echo file_get_contents($tmpl_pre);

      echo $out;

      $tmpl_post = $tmpl . '_post';
      if(file_exists($tmpl_post))
        echo file_get_contents($tmpl_post);
      //end
    } else
    {
      echo 'No file ' . $tmpl;
      die;
    }
  } else
  {
    echo 'Nothing todo...';
    die;
  }
?>